/* SegorKat - A viewer for the electronic catalog of  
*            Segor electronics (www.segor.de). 
* 
* http://www.mydarc.de/dl9obn/programming/cpp/segorkat 
* 
* Copyright (C) 2005 by Dirk Baechle (dl9obn@darc.de) 
* 
* This program is free software; you can redistribute it and/or 
* modify it under the terms of the GNU General Public License 
* as published by the Free Software Foundation; either version 2 
* of the License, or (at your option) any later version. 
* 
* This program is distributed in the hope that it will be useful, 
* but WITHOUT ANY WARRANTY; without even the implied warranty of 
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
* GNU General Public License for more details. 
* 
* You should have received a copy of the GNU General Public 
* License along with this program; if not, write to the 
* 
* Free Software Foundation, Inc. 
* 675 Mass Ave 
* Cambridge 
* MA 02139 
* USA 
* 
*/

/** 
\file SegorKat.cpp 
\author Dirk Baechle 
\date 2005-07-02 
\version 1.0 
*/

/*------------------------------------------------------------- Includes */

#include <qapplication.h>
#include <qstring.h>
//Added by qt3to4:
#include <QTranslator>

#include "skMainWindow.h"

/*------------------------------------------------------------ Functions */

/** This is the main function that starts the application.
* @param argc Number of arguments
* @param argv Pointer to the array of arguments
* @return 0 if the application was terminated by \a quit(), 
*         the value given to \a exit() else
*/
int main(int argc, char **argv)
{
    QApplication a(argc, argv);
    QTranslator translator(0);

    skMainWindow *mw = new skMainWindow();
    mw->setCaption( "SegorKat" );
    a.setMainWidget( mw );
    mw->resize(600, 450);
    mw->show();

    a.connect( &a, SIGNAL( lastWindowClosed() ), &a, SLOT( quit() ) );
    int result = a.exec();
    delete mw;
    return result;
}


