/* SegorKat - A viewer for the electronic catalog of  
*            Segor electronics (www.segor.de). 
* 
* http://www.mydarc.de/dl9obn/programming/cpp/segorkat 
* 
* Copyright (C) 2005 by Dirk Baechle (dl9obn@darc.de) 
* 
* This program is free software; you can redistribute it and/or 
* modify it under the terms of the GNU General Public License 
* as published by the Free Software Foundation; either version 2 
* of the License, or (at your option) any later version. 
* 
* This program is distributed in the hope that it will be useful, 
* but WITHOUT ANY WARRANTY; without even the implied warranty of 
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
* GNU General Public License for more details. 
* 
* You should have received a copy of the GNU General Public 
* License along with this program; if not, write to the 
* 
* Free Software Foundation, Inc. 
* 675 Mass Ave 
* Cambridge 
* MA 02139 
* USA 
* 
*/

/** 
\file skHuffNode.cpp 
\author Dirk Baechle 
\date 2005-07-02 
\version 1.0 
*/

/*------------------------------------------------------------- Includes */

#include "skGlobal.h"
#include "skHuffNode.h"
#include "skFileIO.h"

/*------------------------------------------------------ Class functions */

/** Default constructor for the \a skHuffNode class.
*/
skHuffNode::skHuffNode() : 
        Parent(0),
	Left(0),
        Right(0)
{
  ;
}

/** Copy constructor for the \a skHuffNode class.
* @param elem Node that is copied
*/
skHuffNode::skHuffNode(const skHuffNode &elem) 
{
  Parent = elem.Parent;
  Left = elem.Left;
  Right = elem.Right;
}

/** Overloaded copy operator ``=''.
* @param elem Node that is copied
*/
skHuffNode &skHuffNode::operator= (const skHuffNode &elem)
{
  if (this == &elem)
    return *this;

  Parent = elem.Parent;
  Left = elem.Left;
  Right = elem.Right;

  return *this;
}

/** Reads the single entries from the given file stream \a f.
* @param f File stream, the entries are read from
* @return OK if entry was read successfully, ERROR else
*/
int skHuffNode::read(ifstream &f)
{
  // Read index to parent (=uptree)
  Parent = readInt(f);
  // Read index to left branch (=tree1)
  Left = readInt(f);
  // Read index to right branch (=tree2)
  Right = readInt(f);

  return OK;
}

