/* SegorKat - A viewer for the electronic catalog of  
*            Segor electronics (www.segor.de). 
* 
* http://www.mydarc.de/dl9obn/programming/cpp/segorkat 
* 
* Copyright (C) 2005 by Dirk Baechle (dl9obn@darc.de) 
* 
* This program is free software; you can redistribute it and/or 
* modify it under the terms of the GNU General Public License 
* as published by the Free Software Foundation; either version 2 
* of the License, or (at your option) any later version. 
* 
* This program is distributed in the hope that it will be useful, 
* but WITHOUT ANY WARRANTY; without even the implied warranty of 
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
* GNU General Public License for more details. 
* 
* You should have received a copy of the GNU General Public 
* License along with this program; if not, write to the 
* 
* Free Software Foundation, Inc. 
* 675 Mass Ave 
* Cambridge 
* MA 02139 
* USA 
* 
*/

/** 
\file skMainWindow.h 
\author Dirk Baechle 
\date 2005-07-02 
\version 1.0 
*/

#ifndef SK_MAINWINDOW_H
#define SK_MAINWINDOW_H

/*------------------------------------------------------------- Includes */

#include <q3mainwindow.h>
//Added by qt3to4:
#include <Q3PopupMenu>

/*------------------------------------------------------ Forward class declarations */

class QString;
class Q3PopupMenu;
class skCentralWidget;

/*-------------------------------------------------------------- Classes */

/** The main window for this application.
* Provides a menu and a toolbar with entries for opening, saving files
* a.s.o.
*/
class skMainWindow: public Q3MainWindow
{
    Q_OBJECT

public:
    skMainWindow();

protected:

protected slots:
    void slotAbout();

private:
    void setupMenuBar();
    void setupCentralWidget();

    /** Popup menu for the ``file'' menu */
    Q3PopupMenu *pmFile;
    /** Popup menu for the ``order list'' menu */
    Q3PopupMenu *pmOrder;
    /** Popup menu for the ``info'' menu */
    Q3PopupMenu *pmInfo;
    /** The central widget */
    skCentralWidget *view;

};

#endif

