/* SegorKat - A viewer for the electronic catalog of  
*            Segor electronics (www.segor.de). 
* 
* http://www.mydarc.de/dl9obn/programming/cpp/segorkat 
* 
* Copyright (C) 2005 by Dirk Baechle (dl9obn@darc.de) 
* 
* This program is free software; you can redistribute it and/or 
* modify it under the terms of the GNU General Public License 
* as published by the Free Software Foundation; either version 2 
* of the License, or (at your option) any later version. 
* 
* This program is distributed in the hope that it will be useful, 
* but WITHOUT ANY WARRANTY; without even the implied warranty of 
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
* GNU General Public License for more details. 
* 
* You should have received a copy of the GNU General Public 
* License along with this program; if not, write to the 
* 
* Free Software Foundation, Inc. 
* 675 Mass Ave 
* Cambridge 
* MA 02139 
* USA 
* 
*/

/** 
\file skSegorArticle.h 
\author Dirk Baechle 
\date 2005-07-02 
\version 1.0 
*/

#ifndef SK_SEGORARTICLE_H
#define SK_SEGORARTICLE_H

/*------------------------------------------------------------- Includes */

#include "skSegorPrice.h"

#include <iostream>
#include <string>
#include <fstream>
#include <vector>

using namespace std;

/*-------------------------------------------------------------- Classes */

/** Parameters for a single article in the Segor archive. */
class skSegorArticle
{
public:
    skSegorArticle();
    skSegorArticle(const skSegorArticle &elem);
    skSegorArticle& operator= (const skSegorArticle &elem);
    
    int read(ifstream &f);
    void getPriceInfo(int *vpe, int *minUnits, double *minPrice);
    void getCurrentPrice(double *nettoPrice, double *bruttoPrice);

    /** ID of the parent category */
    string parentID;
    /** Name */
    string Name;
    /** Description */
    string Description;
    /** Other names for this item */
    string OtherNames;
    /** Status, can be 1-4 */
    int Status;
    /** Is ``1'' if prices are given for 1 order unit, or ``2'' for 100 order units */
    int UnitPriceKey;
    /** Key for the added-value tax */
    int AVTaxKey;
    /** Number of items per order unit */
    int PerUnit;
    /** Number of ordered units */
    int OrderedUnits;

    /** Prices */
    vector<skSegorPrice> plPrices;

protected:

private:

};

#endif

