/* SegorKat - A viewer for the electronic catalog of  
*            Segor electronics (www.segor.de). 
* 
* http://www.mydarc.de/dl9obn/programming/cpp/segorkat 
* 
* Copyright (C) 2005 by Dirk Baechle (dl9obn@darc.de) 
* 
* This program is free software; you can redistribute it and/or 
* modify it under the terms of the GNU General Public License 
* as published by the Free Software Foundation; either version 2 
* of the License, or (at your option) any later version. 
* 
* This program is distributed in the hope that it will be useful, 
* but WITHOUT ANY WARRANTY; without even the implied warranty of 
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
* GNU General Public License for more details. 
* 
* You should have received a copy of the GNU General Public 
* License along with this program; if not, write to the 
* 
* Free Software Foundation, Inc. 
* 675 Mass Ave 
* Cambridge 
* MA 02139 
* USA 
* 
*/

/** 
\file skSegorCategory.h 
\author Dirk Baechle 
\date 2005-07-02 
\version 1.0 
*/

#ifndef SK_SEGORCATEGORY_H
#define SK_SEGORCATEGORY_H

/*------------------------------------------------------------- Includes */

#include "skSegorSubCategory.h"

#include <iostream>
#include <string>
#include <fstream>
#include <vector>

using namespace std;

/*------------------------------------------------------ Forward class declarations */

#ifdef SEGORKAT_QT
class Q3ListView;
class Q3ListViewItem;
class QComboBox;
#endif

/*------------------------------------------------------ Class functions */

/** Parameters for a category (=Warenhauptgruppe) in the Segor archive. */
class skSegorCategory
{
public:
    skSegorCategory();
    skSegorCategory(const skSegorCategory &elem);
    skSegorCategory& operator= (const skSegorCategory &elem);
    
    int read(ifstream &f);
    void InsertSubCategory(const skSegorSubCategory &category);
    void InsertSubSubCategory(const skSegorSubSubCategory &category);
    void InsertArticle(const skSegorArticle &article);

#ifdef SEGORKAT_QT
    void UpdateCategory(Q3ListView *lvParts,
                        QComboBox *cbSubCategory,
                        QComboBox *cbSubSubCategory,
                        int categoryIndex);
    void UpdateSubCategory(Q3ListView *lvParts,
                           QComboBox *cbSubSubCategory,
                           int categoryIndex,
                           int subCategoryIndex);
    void UpdateSubSubCategory(Q3ListView *lvParts,
                              int categoryIndex,
                              int subCategoryIndex,
                              int subsubCategoryIndex);
    void UpdateArticleItem(Q3ListViewItem *lviItem,
                           int categoryIndex,
                           int subcategoryIndex,
                           int subsubCategoryIndex,
                           int articleIndex);

    void SearchArticles(Q3ListView *lvParts, 
                        const QString &search,
                        bool inName,
                        bool inDescription,
                        bool inOtherNames,
                        bool caseSensitive,
                        int categoryIndex);
    void ShowArticleInfo(int subcategoryIndex,
                         int subsubcategoryIndex,
                         int articleIndex);



    void OrderArticle(int subcategoryIndex,
                      int subsubcategoryIndex,
                      int articleIndex);
    void OrderedArticles(Q3ListView *lvParts, 
                         int categoryIndex);

    void getHtmlOrderTable(QString &sTable); 
    void getTextOrderTable(QString &sTable, 
                           const QString &sepString,
                           int ColCountWidth, 
                           int ColArticleWidth, 
                           int ColNettoWidth,
                           int ColBruttoWidth);

#endif
    void SetOrderArticle(int subcategoryIndex,
                         int subsubcategoryIndex,
                         int articleIndex,
                         int orderedUnits);
    void DisOrderAll();

    void UpdateOrderInfo(int *articleCount, 
                         double *nettoSum,
                         double *bruttoSum);

    /** ID of the category */
    string ID;
    /** Description */
    string Description;

protected:

private:
    /** List of sub-categories */
    vector<skSegorSubCategory> sclCategories;

};

#endif

