/* SegorKat - A viewer for the electronic catalog of  
*            Segor electronics (www.segor.de). 
* 
* http://www.mydarc.de/dl9obn/programming/cpp/segorkat 
* 
* Copyright (C) 2005 by Dirk Baechle (dl9obn@darc.de) 
* 
* This program is free software; you can redistribute it and/or 
* modify it under the terms of the GNU General Public License 
* as published by the Free Software Foundation; either version 2 
* of the License, or (at your option) any later version. 
* 
* This program is distributed in the hope that it will be useful, 
* but WITHOUT ANY WARRANTY; without even the implied warranty of 
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
* GNU General Public License for more details. 
* 
* You should have received a copy of the GNU General Public 
* License along with this program; if not, write to the 
* 
* Free Software Foundation, Inc. 
* 675 Mass Ave 
* Cambridge 
* MA 02139 
* USA 
* 
*/

/** 
\file skTextCell.cpp 
\author Dirk Baechle 
\date 2005-07-02 
\version 1.0 
*/

/*------------------------------------------------------------- Includes */

#include "skTextCell.h"

/** Adds the text cell \a sCell to the string \a t,
* with the given \a cellWidth and alignment \a align.
*/
void addTextCell(QString &t, const QString &sCell,
                 int cellWidth, int align)
{

  // Is the text length larger than, or equal to, the cell width?
  if (((int) sCell.length()) >= cellWidth)
  {
    // Yes, so output a truncated version of the string
    t += sCell.mid(0, cellWidth);
  }
  else
  {
    // There is some space left in the cell, so we have
    // to regard the given alignment...
    int i, imax;
    switch (align)
    {
      case ALIGN_LEFT:   t += sCell;
                         imax = cellWidth - sCell.length();
                         for (i = 0; i< imax; i++)
                           t += " ";
                         break;
      case ALIGN_RIGHT:  imax = cellWidth - sCell.length();
                         for (i = 0; i< imax; i++)
                           t += " ";
                         t += sCell;
                         break;
      case ALIGN_CENTER: imax = (cellWidth - sCell.length())/2;
                         for (i = 0; i< imax; i++)
                           t += " ";
                         t += sCell;
                         imax = cellWidth - (cellWidth - sCell.length())/2;
                         for (i = 0; i < imax; i++)
                           t += " ";
                         break;
    }
  }

}


